<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="fr"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>SacPostal.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">TP3</a> &gt; <a href="index.source.html" class="el_package">poste</a> &gt; <span class="el_source">SacPostal.java</span></div><h1>SacPostal.java</h1><pre class="source lang-java linenums">package poste;

import java.util.*;


public class SacPostal
{
	private ArrayList&lt;ObjetPostal&gt; contenu;
	private double capacite;

	public SacPostal()
<span class="fc" id="L12">	{contenu = new ArrayList&lt;ObjetPostal&gt;(); capacite = 0.5;}</span>

	public SacPostal(double c)
<span class="fc" id="L15">	{contenu = new ArrayList&lt;ObjetPostal&gt;(); capacite = c;}  </span>

	//accesseurs

	public double getCapacite()
<span class="nc" id="L20">	{ return capacite;}</span>

	//accesseur de consultation pour contenu possible

	//autres methodes
	public boolean ajoute(ObjetPostal o)
<span class="pc bpc" id="L26" title="1 of 2 branches missed.">	{if (o.getVolume() + getVolume() &lt;= capacite)</span>
<span class="fc" id="L27">	{contenu.add(o); return true;}</span>
<span class="nc" id="L28">	else return false;</span>
	}

	public double getVolume()
<span class="fc" id="L32">	{double volume=0.005;</span>
<span class="fc bfc" id="L33" title="All 2 branches covered.">	for (int i=0; i &lt; contenu.size(); i++)</span>
<span class="fc" id="L34">		volume += (contenu.get(i)).getVolume();</span>
<span class="fc" id="L35">	return volume;</span>
	}

	public double valeurRemboursement()
<span class="fc" id="L39">	{double valeur=0;</span>
<span class="fc bfc" id="L40" title="All 2 branches covered.">	for (ObjetPostal o:contenu)</span>
	{
<span class="fc" id="L42">		valeur += o.tarifRemboursement();</span>
<span class="fc" id="L43">	}</span>
<span class="fc" id="L44">	return valeur;</span>
	}

	public String toString()
<span class="nc" id="L48">	{return &quot;Sac \ncapacite: &quot;+getCapacite()+</span>
<span class="nc" id="L49">			&quot;\nvolume: &quot;+getVolume()+&quot;\n&quot;+contenu+&quot;\n&quot;;}</span>

	public SacPostal extraireV1(String code)
	{
		// on calcule la capacite necessaire
<span class="fc" id="L54">		double capaciteNecessaire=0;</span>
<span class="fc bfc" id="L55" title="All 2 branches covered.">		for (ObjetPostal o:contenu)</span>
		{
<span class="fc bfc" id="L57" title="All 2 branches covered.">			if (o.getCodePostal().equals(code))</span>
<span class="fc" id="L58">				capaciteNecessaire += o.getVolume();</span>
<span class="fc" id="L59">		}</span>

		// et on utilise sa partie entiere superieure pour avoir une capacite
		// plausible de sac postal, mais ceil(double) retourne un double
		//ca, c'est juste pour montrer une utilisation de java.lang.Math
<span class="fc" id="L64">		SacPostal sac = new SacPostal(Math.ceil(capaciteNecessaire));</span>
<span class="fc" id="L65">		int i=0;</span>
<span class="fc bfc" id="L66" title="All 2 branches covered.">		while (i&lt;contenu.size())</span>
		{ObjetPostal o;
<span class="fc" id="L68">		o = contenu.get(i);</span>
<span class="fc bfc" id="L69" title="All 2 branches covered.">		if (o.getCodePostal().equals(code))</span>
<span class="fc" id="L70">		{sac.ajoute(o);</span>
<span class="fc" id="L71">		contenu.remove(i);</span>
		}
<span class="fc" id="L73">		else i++;</span>
<span class="fc" id="L74">		}      </span>
<span class="fc" id="L75">		return sac;</span>
	}

	public SacPostal extraireV2(String code)
	{
		// On calcule la capacite necessaire et on place les objets
		// dans une arraylist intermediaire
<span class="nc" id="L82">		double capaciteNecessaire=0;</span>
<span class="nc" id="L83">		ArrayList&lt;ObjetPostal&gt; intermed=new ArrayList&lt;ObjetPostal&gt;();</span>

<span class="nc bnc" id="L85" title="All 2 branches missed.">		for (ObjetPostal o:contenu)</span>
		{
<span class="nc bnc" id="L87" title="All 2 branches missed.">			if (o.getCodePostal().equals(code))</span>
			{
<span class="nc" id="L89">				capaciteNecessaire += o.getVolume();</span>
<span class="nc" id="L90">				intermed.add(o);</span>
			}
<span class="nc" id="L92">		}</span>

		// On cree un nouveau sac, 
		// on y transfere l'arrayList intermediaire
		// on enleve du sac courant les elements transferes
<span class="nc" id="L97">		SacPostal sac = new SacPostal(Math.ceil(capaciteNecessaire));</span>
<span class="nc" id="L98">		sac.contenu.addAll(intermed);</span>
<span class="nc" id="L99">		contenu.removeAll(intermed);</span>
<span class="nc" id="L100">		return sac;</span>
	}



}

</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.2.201808211720</span></div></body></html>